/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.PerfilFuncionDAO;
import com.rjconsultores.ventaboletos.entidad.PerfilFuncion;

/**
 *
 * @author rodrigo
 */
@Repository("perfilFuncionDAO")
public class PerfilFuncionHibernateDAO extends GenericHibernateDAO<PerfilFuncion, Integer>
        implements PerfilFuncionDAO {

    @Autowired
    public PerfilFuncionHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<PerfilFuncion> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

        return c.list();
    }

	@Override
	public boolean usuarioPossuiPermissaoFuncionalidade(Integer usuarioId, String descRuta) {
		StringBuilder instrucao = new StringBuilder();
		instrucao.append("select pf.* from perfil_funcion pf ");
		instrucao.append("inner join funcion_sistema fs on pf.funcionsistema_id = fs.funcionsistema_id ");
		instrucao.append("inner join usuario_perfil up on pf.perfil_id = up.perfil_id ");
		instrucao.append("where pf.activo = 1 ");
		instrucao.append("and up.usuario_id = :usuarioId ");
		instrucao.append("and fs.descruta = :descruta ");
		
		Query query = getSession().createSQLQuery(instrucao.toString()).addEntity(PerfilFuncion.class);
		query.setInteger("usuarioId", usuarioId);
		query.setString("descruta", descRuta);
		
		PerfilFuncion perfilFuncion = (PerfilFuncion)query.uniqueResult();
		
		return perfilFuncion != null && !perfilFuncion.getIndLectura();
	}
}
